<?php

/* draw pixel art of XPM file page */
/* NOTE that xpm files only have 256 colors */

/*
 Copyright (C) Johan Ceuppens 2013

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
?>

<?php
include("../include/root.php");
include(utilDir("util.php"));
include(miscDir("css/cssutil.php"));
include(miscDir("css/cssjs.php"));
include('pixelart.util.php');

function xpmMakeHexColorArray()
{

	$array = array();

	/* construct php array of hex colors (== pixels) */
	$i = 0;
	if (!isset($_SESSION['arraylength'])) {
		return $array;
	}
	while ($i < $_SESSION['arraylength']) {
		$array_push($array, $_SESSION['array' . $i]);
		$i++;	
	}	
	return $array;
} 

function genAscii()
{

	if (!isset($_SESSION['asciisymbol'])) {
		$_SESSION['asciisymbol'] = 0;
	}

	$_SESSION['asciisymbol'] += 1;

	if ($_SESSION['asciisymbol'] >= 256) {
		$_SESSION['asciierr'] = 1;
	}
}

function error_console()
{
	if (isset($_SESSION['asciierr'])) {
		if ($_SESSION['asciierr'] == 1) {
			echo '<b>Error Console: </b>';
			echo 'More than 256 colors, losing rest of pixels.<br>';
		}
	}
}
	
function xpmWriteToScreen($array)
{
	
	$differentcolors = array(); /* ascii => hex */
	$differentcolors2 = array(); /* hex => ascii */
	$i = 0;
	while ($i < count($array)) {
		/* add color for xpm header */
		//if (!isset($differentcolors[$array[$i]])) {
			genAscii();
			//array_push($differentcolors[$_SESSION['asciisymbol'] => $array[$i]);
			//array_push($differentcolors2[$array[$i] => $_SESSION['asciisymbol']);
			$differentcolors[$_SESSION['asciisymbol']] = $array[$i];
			$differentcolors2[$array[$i]] = $_SESSION['asciisymbol'];
		//}
		$i++;

	}
	$i = 0;
	foreach ($differentcolors as $key => $val)	
		echo '" ';
		if (isset($key)) { echo $key; }
		echo ' c ';
		if (isset($val)) { echo $val; }
		echo ' "';
		echo '<br>';
	} 
	$i = 0; $j = 0;

	if (isset($_SESSION['xpmheight']) and isset($_SESSION['xpmwidth'])) {
	while ($i < $_SESSION['xpmheight']) {
		while ($j < $_SESSION['xpmwidth']) {	
			echo $differentcolors2[$array[$i * $_SESSION['xpmwidth'] + $j]];
		$j++;
		echo '<br>';
		}
	$i++;
	echo '<br>';	
	}
}	
printHeader("PixelArt Xpm view");
printBodyInit();
	session_start();
	$_SESSION['asciisymbol'] = undef;
	xpmWriteToScreen(xpmMakeHexColorArray());	
	//error_console();
printBodyHTMLClose();

?>
